const express = require('express');
const io = require("socket.io-client");
//const socket = io('ws://tabu-server.willers.digital');
const socket = io('ws://localhost:3000');

function createRouter(db) {
    const router = express.Router();

    socket.on('Test:newRound', (data) => {
        console.log('NEW ROUND FROM: ', data)
    });

    socket.on('Test:endRound', (data) => {
        console.log('END ROUND FROM: ', data)
    });

    const isTrue = function(req, res) {
        res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
    };

    const isSession = function isSession(req, res, next) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT SessionName FROM Session WHERE SessionName = \''+spielname+'\';';
            console.log('isSession:' ,sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        return res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        if (results.length > 0) {
                            next();
                        } else {
                            return res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'false'});
                        }
                    }
                }
            );
        } else {
            return res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const getGamestatus = function(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT SessionID, Red, Blue, RedTurn, ActiveExplainer, ActiveCard FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('getGamestatus: ',sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json(
                            {
                                status: 'true',
                                sessionID: results[0].SessionID,
                                red: results[0].Red,
                                blue: results[0].Blue,
                                redTurn: results[0].RedTurn,
                                activeExplainer: results[0].ActiveExplainer,
                                activeCard: results[0].ActiveCard
                            }
                        );
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const getActiveCard = function getActiveCard(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT ActiveCard FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('getActiveCard: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        console.log(results);
                        res.header('Access-Control-Allow-Origin', "*").status(200).json({cardID: results[0].ActiveCard});
                    }
                })
        }
    };

    const addSession = function addSession(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'INSERT INTO Session (SessionName) VALUES (\"'+spielname+'\");';
            console.log('addSession1: ', sql);
            db.query(
                sql,
                error => {
                    if (error) {
                        console.error(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        //Init new Gamestatus
                        var redTurn = Math.random();
                        redTurn = Math.round(redTurn);
                        const sql = 'INSERT INTO Gamestatus (SessionID, Red, Blue, RedTurn, ActiveExplainer, ActiveCard) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\"), 0, 0, '+redTurn+', 0, 0);';
                        console.log('addSession2: ', sql);
                        db.query(
                            sql,
                            error => {
                                if (error) {
                                    console.error(error);
                                    res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                                } else {
                                    res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                                }
                            }
                        );
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const session = function session(req, res) {
        const sql = 'SELECT * FROM Session';
        console.log('Session: ', sql);
        db.query(
            sql,
            (error, results) => {
                if (error) {
                    console.log(error);
                    res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                } else {
                    res.header('Access-Control-Allow-Origin', "*").status(200).json(results);
                }
            }
        );
    };

    const getS2C = function getS2C(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            let card;
            const sql = 'SELECT Card.CardID, Solution, Tabu1, Tabu2, Tabu3, Tabu4, Tabu5 \n' +
                'FROM Card \n' +
                'WHERE Card.CardID NOT IN \n' +
                '(\n' +
                ' SELECT S2C.CardID\n' +
                ' FROM S2C\n' +
                ' WHERE S2C.CardID IS NOT NULL AND S2C.SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")\n' +
                ');';
            console.log('getS2C1: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        if (results.length > 0) {
                            let random = Math.random() * (results.length - 1);
                            random = Math.round(random);
                            card = results[random];

                            const sqlUpdate = 'UPDATE Gamestatus SET ActiveCard = ' + card.CardID + ' WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"' + spielname + '\")';
                            console.log('getS2C3: ', sql);
                            db.query(sqlUpdate);


                            const sqlInsert = 'INSERT INTO S2C (SessionID, CardID) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"' + spielname + '\"), ' + card.CardID + ');';
                            console.log('getS2C2: ', sql);
                            db.query(sqlInsert);
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    cardID: card.CardID,
                                    solution: card.Solution,
                                    tabu1: card.Tabu1,
                                    tabu2: card.Tabu2,
                                    tabu3: card.Tabu3,
                                    tabu4: card.Tabu4,
                                    tabu5: card.Tabu5,
                                }
                            );
                            socket.emit('newCard', {
                                'sessionName': spielname,
                                'cardID': card.CardID
                            })
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error alle Karten durch'});
                        }
                    }
                });
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const isActiveExplainer = function isActiveExplainer(req, res, next) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT ActiveExplainer FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('isActiveExplainer: ',sql)
            db.query(
                sql,
                (error, results) => {
                     console.log('Result: ', results);
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false', reason: 'Round is active'});
                    } else {
                        const activeExplainer = JSON.parse(results[0].ActiveExplainer);
                        if (activeExplainer === 0) {
                            next();
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false', reason: 'Round is active'});
                        }
                    }
                }
            );
        }
    };

    const newRound = function newRound(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'UPDATE Gamestatus SET ActiveExplainer = 1 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('newRound: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                        socket.emit('newRound', {
                            sessionName: spielname,
                            isOpen: true
                        });
                        setTimeout(endRound, 60000, req);
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false', reason: 'Already Active Game'});
        }
    };

    function endRound(req) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'UPDATE Gamestatus SET RedTurn = (SELECT 1-Gamestatus.RedTurn FROM Gamestatus INNER JOIN Session ON Session.SessionID=Gamestatus.SessionID WHERE Session.SessionName = \"'+spielname+'\"),  ActiveExplainer = 0, ActiveCard =0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('endRound: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        return
                        //res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        socket.emit('endRound', {
                            isOpen: true,
                            sessionName: spielname,
                        });
                        //res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            //res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    }

    const newGame = function newGame(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'UPDATE Gamestatus SET Red = 0, Blue = 0, RedTurn = '+Math.round(Math.random())+' WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('newGame: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                        socket.emit('newGame', {
                            sessionName: spielname
                        });
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    };

    const isPoint4Card = function isPoint4Card(req, res, next) {
        const spielname = req.body.spielname;
        const cardID = req.body.cardID;
        if (spielname.match(/^[0-9a-z]+$/) != null && !isNaN(cardID)) {
            const sql = 'SELECT ActiveCard FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('isPoint4Card: ', sql);
            db.query(sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        resultCardID = results[0].ActiveCard;
                        if (JSON.parse(resultCardID) === JSON.parse(cardID)) {
                            next();
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'false'});
                        }
                    }
                }

            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false body informal'});
        }
    };

    const addPoint = function addPoint(req, res) {
        const spielname = req.body.spielname;
        const team = req.body.team;
        if (spielname.match(/^[0-9a-z]+$/) != null && team.match(/^[0-9a-z]+$/) != null) {
            if (team === 'red') {
                const sql = 'UPDATE Gamestatus SET Red = 1+(SELECT Red FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
                console.log('addPoint Red:', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    red: JSON.parse(req.body.red)+1,
                                    blue: req.body.blue
                                }
                            );
                        }
                    }
                );
            } else if (team === 'blue') {
                const sql = 'UPDATE Gamestatus SET Blue = 1+(SELECT Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
                console.log('addPoint Blue:', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    red: req.body.red,
                                    blue: JSON.parse(req.body.blue)+1
                                }
                            );
                        }
                    }
                );
            }
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    };

    const removePoint = function removePoint(req, res) {
        const spielname = req.body.spielname;
        const team = req.body.team;
        if (spielname.match(/^[0-9a-z]+$/) != null && team.match(/^[0-9a-z]+$/) != null) {
            if (team === 'red') {
                const sql = 'UPDATE Gamestatus SET Red = -1+(SELECT Red FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
                console.log('removePoint Red: ', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    red: JSON.parse(req.body.red)-1,
                                    blue: req.body.blue
                                }
                            );
                        }
                    }
                );
            } else if (team === 'blue') {
                const sql = 'UPDATE Gamestatus SET Blue = -1+(SELECT Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
                console.log('removePoint Blue: ', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    red: req.body.red,
                                    blue: JSON.parse(req.body.blue)-1
                                }
                            );
                        }
                    }
                );
            }
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    };

    const getCard = function getCard(req, res) {
        const cardID = req.body.cardID;
        if (Number.isInteger(cardID)) {
            const sql = 'SELECT CardID, Solution, Tabu1, Tabu2, Tabu3, Tabu4, Tabu5 FROM Card WHERE CardID = \"'+cardID+'\"';
            console.log('getCard: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        if (results.length > 0) {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json({
                                cardID: results[0].CardID,
                                solution: results[0].Solution,
                                tabu1: results[0].Tabu1,
                                tabu2: results[0].Tabu2,
                                tabu3: results[0].Tabu3,
                                tabu4: results[0].Tabu4,
                                tabu5: results[0].Tabu5
                            });
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        }
                    }
                }
            );
        }
    };

    // the routes are defined here

    //Generate new Session
    router.post('/addSession', [addSession]);

    //Check if Session exist
    router.post('/isSession', [isSession, isTrue]);

    //Return all Sessions (Not neccesary)
    router.get('/Session', [session]);

    //Return GameStatus
    router.post('/getGamestatus', ([isSession, getGamestatus]));

    //Return S2C
    router.post('/getS2C', [getS2C]);

    //Start a new Round and lock the game positions
    router.post('/newRound', [isSession, isActiveExplainer, newRound]);

    //End a Round and unlock the game positions and invert RedTurn
    router.post('/endRound', [endRound]);

    //Starts a new Game and resets red and blue and chooses a random value for RedTurn
    router.post('/newGame', [isSession, isActiveExplainer, newGame]);

    //Add Point
    router.post('/addPoint', [isPoint4Card, addPoint]);

    //Remove Point
    router.post('/removePoint', [isPoint4Card, removePoint]);

    //Get ActiveCard
    router.post('/getActiveCard', [isSession, getActiveCard]);

    //Get Card
    router.post('/getCard', [getCard]);

    return router;
}

module.exports = createRouter;
