const Express = require("express")();
const Http = require("http").Server(Express);
const Socketio = require("socket.io")(Http, {
    cors: {
        origin: '*',
    }
});

Http.listen(3000, () => {
    console.log("Listening at :3000...");
});

var currentCard = {};

Socketio.on("connection", socket => {
    console.log('new Socket connect');

    for (var key in currentCard) {
        socket.emit(key, currentCard[key])
    }
    socket.on("newGame", data => {
        console.log('New Game from: ', data.sessionName, ':newGame');
        Socketio.emit(data.sessionName+":newGame", true);
        socket.emit(data.sessionName+":newGame", true);
    });
    socket.on("newCard", data => {
        console.log('New Card from: ', data.sessionName, ':newCard');
        currentCard[data.sessionName+":newCard"] = data.cardID;
        Socketio.emit(data.sessionName+":newCard", data.cardID)
    });
    socket.on("newRound", data => {
        console.log('New Round from: ', data.isOpen);
        Socketio.emit(data.sessionName+":endRound", false);
        socket.emit(data.sessionName+":endRound", false);
        Socketio.emit(data.sessionName+":newRound", true);
        socket.emit(data.sessionName+":newRound", true);
        Socketio.emit(data.sessionName+":newGame", false);
        socket.emit(data.sessionName+":newGame", false);
    });
    socket.on("endRound", data => {
        console.log('End Round from: ', data.isOpen);
        Socketio.emit(data.sessionName+":newRound", false);
        socket.emit(data.sessionName+":newRound", false);
        Socketio.emit(data.sessionName+":endRound", true);
        socket.emit(data.sessionName+":endRound", true);
    });
});

